library(reshape2)
library(stringr)
library(plyr)

raw <- read.delim("weather.txt", stringsAsFactors = FALSE)

# Melt and tidy

raw1 <- melt(raw, id = 1:4, na.rm = T)
raw1$day <- as.integer(str_replace(raw1$variable, "d", ""))
raw1$variable <- NULL
raw1$element <- tolower(raw1$element)

raw1 <- raw1[c("id", "year", "month", "day", "element", "value")]
raw1 <- arrange(raw1, year, month, day, element)

# Cast

tidy <- dcast(raw1, ... ~ element)
